-- ******************************************************************
-- ******************************************************************
-- **                         MorgDKP                              **
-- ******************************************************************
-- ******************************************************************
--
--  You can blame most of this code on Morg(80%).  Rest thanks to Fryguy:)
--

local L = AceLibrary("AceLocale-2.2"):new("MorgDKP")
local BC = AceLibrary("Babble-Class-2.2")
local dewdrop = AceLibrary("Dewdrop-2.0")
local rosterlib = AceLibrary("Roster-2.1")
local roster = rosterlib.roster
local compost = AceLibrary("Compost-2.0")

MorgDKP = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceHook-2.1", "AceConsole-2.0", "AceDB-2.0")

MorgDKP_Version = "4.42"

StaticPopupDialogs["MorgLoot"] = {
	text = TEXT(L["lootquery"]),
	button1 = TEXT(YES),
	button2 = TEXT(NO),
	OnAccept = function()
		MorgDKP:GiveOutLoot()
	end,
	timeout = 0,
	whileDead = 1,
	hideOnEscape = 1,
};

MorgDKP:RegisterChatCommand(
	{L["cmd1"], L["cmd2"]})

function MorgDKP:OnInitialize()
	MorgDKP:RegisterDB("MorgDKPDB")
	MorgDKP:RegisterDefaults('account', {
   	items = { },
    	info = { },
		defaults = { },
		raidlog = { playerinfo = { },
								join = { },
								leave = { },
								bosskills = { },
								loot = { }
							}
	})
	if (not self.db.account.defaults.raidlist) then self.db.account.defaults.raidlist = {[1] = "NONE", [2] = "Molten Core"} end
	if (not self.db.account.defaults.zerosum) then self.db.account.defaults.zerosum = nil end
	if (not self.db.account.defaults.bidwar) then self.db.account.defaults.bidwar = nil end
	if (not self.db.account.defaults.relational) then self.db.account.defaults.relational = nil end
	if (not self.db.account.defaults.quality) then self.db.account.defaults.quality = 4 end
	if (not self.db.account.defaults.raidmembers) then self.db.account.defaults.raidmembers = {[1] = UnitName("player")} end
	self:DoOptions()
end

function MorgDKP:OnEnable()
        
	self.items = { }
	self.TT = { }
	self.querytooltips = { }
	self.queryneeded = nil
	MLmode = nil
	MODactive = nil
	raidmembers = { }
   	Raidchanged = nil
   	
    	self:RegisterEvent("CHAT_MSG_SYSTEM", "SystemEvent")
	self:RegisterEvent("CHAT_MSG_ADDON", "OnAddonMsg")
	self:RegisterEvent("CHAT_MSG_LOOT", "OnLootMsg")
    	self:RegisterEvent("CHAT_MSG_WHISPER", "WhisperHandler")
    	self:RegisterEvent("RosterLib_UnitChanged", "ProcessRosterChange")
	self:RegisterEvent("CHAT_MSG_COMBAT_HOSTILE_DEATH", "HostileDeath")
	self:RegisterEvent("CHAT_MSG_MONSTER_YELL", "HostileYell")
	self:HookStuff()
end

function MorgDKP:OnDisable()
	self:UnhookAll()
end

function MorgDKP:ModActive()
	if not MODactive then 
		DEFAULT_CHAT_FRAME:AddMessage(L["actmod"])
		return false
	end
	return true
end

function MorgDKP:IsRaided()
	if not UnitInRaid("player") then 
		DEFAULT_CHAT_FRAME:AddMessage(L["needraid"])
		return false
	end
	return true
end

function MorgDKP:PlayerinDB(playname, playclass)
	if not self.db.account.info[playname] then 
		self.db.account.info[playname] = { }
		self.db.account.info[playname].points = 0
		self.db.account.info[playname].earned = 0
		self.db.account.info[playname].spent = 0
		self.db.account.info[playname].raidloot = 0
		if playclass then self.db.account.info[playname].class = class end
	end
end
function MorgDKP:GiveOutLoot()
	for ci = 1, GetNumRaidMembers() do
		if GetMasterLootCandidate(ci) == Lootwinner then
  		for li = 1, GetNumLootItems() do
  			local lootIcon, lootName, lootQuantity, rarity = GetLootSlotInfo(li);
  			if lootName == Lootitem then 
  				StaticPopup_Show ("MorgLoot", ItemLink, Lootwinner)
					GiveMasterLoot(li, ci)
					return
				end
  		end
 		end
 	end
 end

function MorgDKP:MakeDewDropMenu(frame, itemlink)
	if itemlink == nil then return end
	_, _, qid = string.find(itemlink, "Hitem:(%d+)")
	local id = tonumber(qid)		
	if( id ) then
		-- make sure it's there
		if not self.db.account.items[id] then self.db.account.items[id] = { } end
		if not self.db.account.items[id].classes then self.db.account.items[id].classes = { } end
			
		-- get cursor pos
		local x,y = GetCursorPosition()
		myid, mylink = id,itemlink
			
		-- build the menu
		self:PrepareRaidmembers()
		dewdrop:Open(frame,
				'children', function(level, value)
						dewdrop:FeedAceOptionsTable(MorgDKP.opts)
					end,
				 'cursorX', true,
			   'cursorY', true
		)
	end
end
	
function MorgDKP:AddRaidDatabase(name)
	if not name then DEFAULT_CHAT_FRAME:AddMessage(L["validname"]) return end
	dbadded = nil
	for num = 2 , 6 do
		if (not self.db.account.defaults.raidlist[num]) then 
			self.db.account.defaults.raidlist[num] = name
			dbadded = 1
			break
		end
	end
	if (not dbadded) then DEFAULT_CHAT_FRAME:AddMessage(L["toomanydb"]) return end
	DEFAULT_CHAT_FRAME:AddMessage(L["editpl"])
	for i , v in pairs(self.db.account.defaults.raidlist) do
		if (i == 1) then 
		elseif (i == 2) then DEFAULT_CHAT_FRAME:AddMessage(v.."= ".." {title => \"DKP"..(i - 1).."\",		url => 'http://<your website>/<dkp site folder>/listmembers.php?show=all'},")
		else DEFAULT_CHAT_FRAME:AddMessage(v.."= ".." DKP"..(i - 1)) end
	end
	DEFAULT_CHAT_FRAME:AddMessage(L["commentout"])
	DEFAULT_CHAT_FRAME:AddMessage("ie. ###	{ title => \"DKP4\",	....")
end

function MorgDKP:DeleteRaidDatabase(num)
	if num == 1 then return end
	DEFAULT_CHAT_FRAME:AddMessage(L["dbremove"]..self.db.account.defaults.raidlist[num])
	self.db.account.defaults.raidlist[num] = nil
	DEFAULT_CHAT_FRAME:AddMessage(L["commentout"])
	DEFAULT_CHAT_FRAME:AddMessage("ie. ###	{ title => \"DKP"..(num - 1).."\",	....")
end
	
function MorgDKP:GiveBOE(id, link)
	if not self:ModActive() then return end
	if not self.db.account.items[id] then DEFAULT_CHAT_FRAME:AddMessage(L["noitem"]); return end
	if not charstring then DEFAULT_CHAT_FRAME:AddMessage(L["validname"]) return end
	if MLmode and (charstring == self.db.account.defaults.mlooter or charstring == self.db.account.defaults.disenchanter) then 
		DEFAULT_CHAT_FRAME:AddMessage(L["nolootrec"])
		return
	end
	MorgDKP:RecordLoot(link, charstring)
end

function MorgDKP:CheckRaid(namequery)
	for pname, data in pairs(roster) do
		pclass = BC[string.upper(string.sub(data.class,1,1))..string.lower(string.sub(data.class,2,-1))]
		--pclass = string.upper(string.sub(data.class,1,1))..string.lower(string.sub(data.class,2,-1))
		if pname == namequery then return true end
	end
	return nil
end
		
function MorgDKP:AddTwink()
		_, _, twink2, twink1 = string.find(twinkstring, "(%a+) (%a+)")
		if twink1 == nil or twink2 == nil then 
			DEFAULT_CHAT_FRAME:AddMessage(L["twinkaltmain"])
			return
		end
		twinkmain = string.upper(string.sub(twink1,1,1))..string.sub(twink1,2,-1)
		twinkalt = string.upper(string.sub(twink2,1,1))..string.sub(twink2,2,-1)
		mainpoints = 0
		if MorgDKP.db.account.info[twinkmain] then mainpoints = MorgDKP.db.account.info[twinkmain].points 
		else DEFAULT_CHAT_FRAME:AddMessage(L["nomain"]) return end
		local var = nil
		if MorgDKP.db.account.info[twinkalt] then 
			DEFAULT_CHAT_FRAME:AddMessage(L["transfer"]..tostring(mainpoints)..L["dkpp"]..twinkmain..L["to"]..twinkalt)
			var = 1
		end	
		if not var then 
			DEFAULT_CHAT_FRAME:AddMessage(L["addnewchar"]..twinkalt.." with "..tostring(mainpoints)..L["dkpp"])
			MorgDKP.db.account.info[twinkalt] = { } 
		end
		MorgDKP.db.account.info[twinkalt].points = mainpoints
		MorgDKP.db.account.info[twinkalt].raidloot = 0
		table.insert(MorgDKP.db.account.info[twinkmain].aliases, {raid = self.db.account.defaults.raid, alt = twinkalt})
end	


function MorgDKP:ChangeDKP()
		_, _, char, points = string.find(charstring, "(%a+) (%d+)")
		if char == nil or points == nil then 
			DEFAULT_CHAT_FRAME:AddMessage(L["charpoints"])
			return
		end
		character = string.upper(string.sub(char,1,1))..string.sub(char,2,-1)
		pointval = tonumber(points)
		local type = L["add"]
		if MorgDKP.db.account.info[character] then 
			mainpoints = MorgDKP.db.account.info[character].points 
			oldmainpoints = mainpoints
			if adding then mainpoints = mainpoints + pointval 
			else mainpoints = mainpoints - pointval ; type = L["sub"] end
			DEFAULT_CHAT_FRAME:AddMessage(type..points..L["dkpp"]..character..L["olddkp"]..tostring(oldmainpoints)..L["newdkp"]..tostring(mainpoints))
			MorgDKP.db.account.info[character].points = mainpoints
			return
		end
		DEFAULT_CHAT_FRAME:AddMessage(character..L["notexi"])
end	

function MorgDKP:GetPlayersNeedItem(item)
	if (not UnitInRaid("player")) then return end
	needquery = self:HasItem(item)
	if not needquery then return end
	reportpoints = { }
	for qname in pairs(needquery) do
		self:PlayerinDB(qname)
		table.insert(reportpoints, {name = qname, points = self.db.account.info[qname].points})
	end
	table.sort(reportpoints, function(a,b)
				return a.points>b.points
				end)	
	return reportpoints
end

function MorgDKP:WhisperHandler(txt, sender)
	if not UnitInRaid("player") then return end
	if not string.find(string.upper(txt), "DKPLIST") then return end 
	if not MorgDKP:CheckRaid(sender) then return end
	local senderclass = pclass
	dkplist = { }
	local args = {self:Explode(txt, " ")}
	if string.upper(args[2]) == "ALL" then 
		txt = "dkplist Paladin Warlock Druid Mage Priest Rogue Hunter Warrior"
		args = {self:Explode(txt, " ")}
	end
	local classdone = nil
	numargs = #args 
	args[numargs + 1] = senderclass
	for i = 2, numargs + 1 do
		local class = string.upper(string.sub(args[i],1,1))..string.sub(args[i],2,-1)
		if class == senderclass and not classdone then classdone = 1 
		else 
			i = i + 1
			if i > numargs + 1 then break end
			local class = string.upper(string.sub(args[i],1,1))..string.sub(args[i],2,-1)
		end
		for pname, data in pairs(roster) do
			pclass = BC[string.upper(string.sub(data.class,1,1))..string.lower(string.sub(data.class,2,-1))]
			--pclass = string.upper(string.sub(data.class,1,1))..string.lower(string.sub(data.class,2,-1))
			if pclass == class then 
				table.insert(dkplist, {pname, class, (MorgDKP.db.account.info[pname].points or 0)})
			end
		end
	end
	table.sort(dkplist, function(a,b)
   	if a[3] > b[3] then	return true
		else return false end
		end)
	SendChatMessage(L["dkpstand"]..self.db.account.defaults.raid..":", "WHISPER", "COMMON", sender)
	local spaces = "                                                                                                                                    "
	local numspace = {10, 7, 5, 2, 1}
	for i,v in ipairs(dkplist) do
		local message = string.upper(v[1])
		l , j ,m = string.len(v[1]), string.len(v[2]), string.len(v[3])
		message = message ..string.sub(spaces,1,(45 - self:CalcSpaces(string.upper(v[1]))))..string.upper(v[2])
		message = message ..string.sub(spaces,1,(self:CalcSpaces(string.upper(v[2]))))..string.sub(spaces,1,numspace[string.len(v[3])])..v[3].."   DKP"
		SendChatMessage(message, "WHISPER", "COMMON", sender)
	end
end
		

function MorgDKP:Scan(arg)
	for i = 1, GetNumRaidMembers() do
		--self.SetClass(UnitName("target"), UnitClass("target"))
		if not self.db.account.info[UnitName("raid"..i)] then
			self:PlayerinDB(UnitName("raid"..i))
			self.db.account.info[UnitName("raid"..i)] = {
				items = { }}
			self.db.account.info[UnitName("raid"..i)].points = 0
			self.db.account.info[UnitName("raid"..i)].earned = 0
			self.db.account.info[UnitName("raid"..i)].spent = 0
			self.db.account.info[UnitName("raid"..i)].raidloot = 0
		end
		local updated = nil
		self.db.account.info[UnitName("raid"..i)].class = UnitClass("raid"..i)
		for slot, loc in pairs(L["scanslots"]) do
			local itemLink = GetInventoryItemLink("raid"..i, GetInventorySlotInfo(slot))
			if itemLink then
				local _, _, itemCode = strfind(itemLink, "(%d+):")
				if not self.db.account.info[UnitName("raid"..i)].items then
					self.db.account.info[UnitName("raid"..i)].items = { }
				end
				if not self.db.account.info[UnitName("raid"..i)].items[loc] then
					self.db.account.info[UnitName("raid"..i)].items[loc] = { }
				end
				self.db.account.info[UnitName("raid"..i)].items[loc][itemLink] = 1
				updated = 1
			else
				--DEFAULT_CHAT_FRAME:AddMessage("slot: "..loc.."; no item")
			end
		end

		if updated then
			-- mark them as being updated
			self.db.account.info[UnitName("raid"..i)].lastupdate = date()
		end

		--DEFAULT_CHAT_FRAME:AddMessage("Scanned "..UnitName("raid"..i))
	end
end


function MorgDKP:OnLootMsg()
	if (not MODactive) or (not UnitInRaid("player")) then return end
	local sPlayer, sLink;
	local iStart, iEnd, sPlayerName, sItem = string.find( arg1, L["MORGTRACKER_LOOT_RECEIVES1"] )
  	if ( sPlayerName ) then
		_, _, _, _, itemCount = string.find( arg1, L["MORGTRACKER_LOOT_RECEIVES1_COUNT"] )
    		sPlayer = sPlayerName
		sLink = sItem
	else
		local iStart, iEnd, sItem = string.find( arg1, L["MORGTRACKER_LOOT_RECEIVES2"] )
    		if ( iStart ) then
			sPlayer = UnitName("player")
			sLink = sItem
			_, _, _, itemCount =  string.find( arg1, L["MORGTRACKER_LOOT_RECEIVES2_COUNT"] )
    		end
	end
	itemCount = tonumber(itemCount)
	if(not itemCount) then
		itemCount = 1
	end
	-- Make sure there is a link
	if MLmode and (sPlayer == self.db.account.defaults.mlooter or sPlayer == self.db.account.defaults.disenchanter) then return end
	if (not MorgDKP:CheckRaid(sPlayer)) then return end
	if ( sLink and sPlayer ) then
		MorgDKP:RecordLoot(sLink, sPlayer)
	end
end

-- Code by Kaelten (split & explode)
function MorgDKP:Split(string, sep)
	if (not string) then error("Bad String", 2)     end
	local x = strfind(string , sep) or 0
	return (tonumber(strsub(string, 1, x-1)) or strsub(string, 1, x-1)), (tonumber(strsub(string, x+1)) or strsub(string, x+1))
end
function MorgDKP:Explode(string, sep)
	if (not string) then return nil end
	local a, b = self:Split(string, sep)
	if (not b or b == "") then return a; end
	if (not strfind(b or "", sep)) then return a, b; end
	return a, self:Explode(b, sep)
end 

function MorgDKP:RecordLoot(item, player)
	local _, _, sColor = string.find(item, "|c(%x+)")
	local _,_, itemId = string.find(item, "item:(%d+):")
	itemId = tonumber(itemId)
	local sName, iString, iQuality, _, _, class, subclass, _, iEquipLoc, iconGIF = GetItemInfo(itemId)
	_, _, iconGIF = string.find(iconGIF, "^.*\\(.*)$")
	local _,_, itemIDstring= string.find(iString, "item:(%d+:%d+:%d+:%d+)")
	if iQuality < self.db.account.defaults.quality then return end
	local lootTime = date()
	local lastboss = self.db.account.raidlog.lastboss
	local BossMob = L["MorgTracker_BossUnitTriggers"]["DEFAULTBOSS"]
	local TargetMob = UnitName("target")
	if ( not TargetMob ) or ( TargetMob == "" ) then
		if MorgDKP.db.account.raidlog.lootbuffer then
			if (lastboss) and (MorgDKP.db.account.raidlog.lootbuffer[sName]) then BossMob = lastboss end
		end
	else BossMob = L["MorgTracker_BossUnitTriggers"][TargetMob]
		if (BossMob == "IGNORE") or (not BossMob) then BossMob = L["MorgTracker_BossUnitTriggers"]["DEFAULTBOSS"] end
	end
	self:PlayerinDB(player)
	points = self.db.account.info[player].points 
	itempoints = 0
	if (self.db.account.items[itemId]) then itempoints = self.db.account.items[itemId].points end
	Zone = GetRealZoneText()
	table.insert(self.db.account.raidlog.loot,
					{
						["ItemName"] = sName,
						["ItemID"] = itemIDstring,
						["Icon"] = iconGIF,					
						["Class"] = class,
						["SubClass"] = subclass,
						["Color"] = sColor,
						["Count"] = itemCount,
						["Player"] = player,
						["Costs"] = itempoints,
						["Time"] = lootTime,
						["Zone"] = Zone,
						["Boss"] = BossMob,
						["Note"] = "![CDATA[ - Zone: "..Zone.." - Boss: "..BossMob.."]]"
					}
				)
	slot = L["slots"][iEquipLoc]
	points = points - itempoints
	self.db.account.info[player].points = points 
	self.db.account.info[player].spent = self.db.account.info[player].spent + itempoints
	self.db.account.info[player].raidloot = 1 
	if self.db.account.defaults.zerosum and (tonumber(itempoints) > 0) then self:AddZeroSumPoints(itempoints) end
	DEFAULT_CHAT_FRAME:AddMessage(player..L["receive"]..item.." for "..tostring(itempoints).." DKP")
	if not slot then return end
	if not self.db.account.info[player].items then
		self.db.account.info[player].items = { }
	end
	if not self.db.account.info[player].items[slot] then
		self.db.account.info[player].items[slot] = { }
	end
	self.db.account.info[player].items[slot][item] = TRUE
	--DEFAULT_CHAT_FRAME:AddMessage("slot: "..iEquipLoc.."; item: "..sLink.."; code: "..itemId)
end

function MorgDKP:PrepareRaidmembers()
	--Rebuild raid members
	self.db.account.defaults.raidmembers = nil
	self.db.account.defaults.raidmembers = { }
	raidmembers = nil
	raidmembers = { }
	for name, data in pairs(roster) do
		if (data.class ~= L["pet"]) then table.insert(raidmembers, name) end
	end
	table.sort(raidmembers, function(a,b)
  		if a < b then	return true
			else return false end
		end)
	for _ ,name in pairs(raidmembers) do
		table.insert(self.db.account.defaults.raidmembers, name)
	end
	MorgDKP:ReclaimAll()
				
	--Update ML
	lootmethod, masterlooterID = GetLootMethod()
	if (not masterlooterID) then looter = "?" 
	elseif (masterlooterID == 0) then looter = UnitName("player") 
	elseif (masterlooterID > 0) then looter = UnitName("party"..masterlooterID) end
	if (looter ~= "?") then MorgDKP.db.account.defaults.mlooter = looter end
	MorgDKP:ReclaimML()
end

function MorgDKP:AddZeroSumPoints(points)
	addpoints = math.floor((points/GetNumRaidMembers()) + 0.5)
	local counter = 0
	for name in pairs(roster) do
    		if(name and name ~= "" and name ~= "UNKNOWN") then
			local tbl = roster[name]
			if (tbl.class ~= L["pet"]) and (tbl.oldclass ~= L["pet"]) then 
				self.db.account.info[name].points = self.db.account.info[name].points + addpoints
				self.db.account.info[name].earned = self.db.account.info[name].earned + addpoints
				counter = counter + 1
			end
		end
	end
	DEFAULT_CHAT_FRAME:AddMessage(L["add"]..tostring(addpoints)..L["pointsto"]..tostring(counter)..L["attend"])
end
